package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WFUserCandidate;
import com.sa.ibiz.demo.demo.service.WFUserCandidateService;
import com.sa.ibiz.demo.demo.service.dto.WFUserCandidateSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wfusercandidate")
public class WFUserCandidateResource
{
	@Autowired
	private WFUserCandidateService service;


	@GetMapping(value = "/{id}")
	public ResponseEntity<WFUserCandidate> get(@Validated @PathVariable String id){
		WFUserCandidate data=new WFUserCandidate();
		data.setWfusercandidateid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("工作流用户候选者[get]操作发生错误","WFUserCandidate",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WFUserCandidate> checkKey(@Validated @RequestBody WFUserCandidate data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户候选者[checkKey]操作发生错误","WFUserCandidate",data.getWfusercandidateid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WFUserCandidate> getDraft(@Validated @RequestBody WFUserCandidate data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户候选者[getDraft]操作发生错误","WFUserCandidate","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WFUserCandidate> remove(@Validated @RequestBody WFUserCandidate data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户候选者[remove]操作发生错误","WFUserCandidate",data.getWfusercandidateid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WFUserCandidate> create(@Validated @RequestBody WFUserCandidate data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户候选者[create]操作发生错误","WFUserCandidate",data.getWfusercandidateid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<WFUserCandidate> update(@Validated @RequestBody WFUserCandidate data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户候选者[update]操作发生错误","WFUserCandidate",data.getWfusercandidateid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WFUserCandidate>> searchDefaultPage(@Validated @RequestBody WFUserCandidateSearchFilter filter){
		Page<WFUserCandidate> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WFUserCandidate>> listDefault(@Validated @RequestBody WFUserCandidateSearchFilter filter){
		List<WFUserCandidate> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
